#include "servidor.h"

int mail(struct ElemVideo *elem);

time_t InHoramax(int fifoname)  {
    char buffer[32];
    struct tm fecha={0,0,0,0,0,0,0,0};    //    ptm es temporal
    time_t temep;

    printf("******* Ingrese los datos del plazo mximo para ver el video *******\n");;
    printf("Ingrese el da (1-31)\n");
    read(fifoname,buffer, sizeof(buffer));
    fecha.tm_mday=atoi(buffer);

    printf("Ingrese el mes (1-12)\n");
    read(fifoname,buffer, sizeof(buffer));
    fecha.tm_mon=(atoi(buffer)-1);

    printf("Ingrese el ao 2xxx)\n");
    read(fifoname,buffer, sizeof(buffer));
    fecha.tm_year=atoi(buffer)-1900;

    printf("Ingrese a hora (0-23)\n");
    fflush(stdout);
    read(fifoname,buffer, sizeof(buffer));
    fecha.tm_hour=atoi(buffer);

    printf("Ingrese los minutos (0-59)\n");
    fflush(stdout);
    read(fifoname,buffer, sizeof(buffer));
    fecha.tm_min=atoi(buffer);
                                                                    //
    return (mktime(&fecha));
}

/*retorna el tiempo en el cual fue prog el video o -1 si no se puede prog */



time_t InsVideo(struct ListaVideo *lista,struct ElemVideo *elem) {
    int i;
    struct ElemVideo elemtemp;
    struct tm *ptm;
    char fecha[50],*username;
    pid_t pid;
    int pfd[2],i2, status;
    time_t actual;


    printf("entre a la funcion\n");
   	actual=time(NULL);
    if (lista->primero==lista->ultimo)  { /*si lista esta  vacia*/

        elem->horaini=(time(NULL)+60);
        elem->horaterm=elem->horaini+(elem->duracion);
        lista->video[lista->ultimo]=*elem;
        lista->ultimo+=1;
        return(elem->horaini);
    }


   if (( (lista->video[lista->ultimo-1].horaterm) +60+(elem->duracion)) <=(elem->horamax))   {
                                    //pregunta si hay tiempo para ver el video al ultimo

        elem->horaini= lista->video[lista->ultimo-1].horaterm+60;
        elem->horaterm=elem->horaini+elem->duracion;
        lista->video[lista->ultimo]=*elem;
        lista->ultimo=(int)((lista->ultimo+1)%max);
        return(elem->horaini);
    }
    else    {   //hay que cambiarlo por uno ya programado

        elem->horaini=lista->video[lista->ultimo-1].horaterm+60; //guarda la hora donde emezar el video que salga
        i=lista->ultimo-1;
        if(i==(-1))
            i=max;
            /*hay que hacer que revise el primero*/
        while(i!=lista->primero)    {
            if((lista->video[i].horamax >=(elem->horaini+lista->video[i].duracion))&&\
                (elem->duracion<=lista->video[i].duracion)&&(actual<lista->video[i].horaini))   {
            /*si el video puesto al final alcanza y el espacio es el suficiente para el*/
            /*nuevo, entonces swap*/
                elemtemp=lista->video[i];    /*guardamos el original*/
                lista->video[i]=*elem;
                lista->video[i].horaini=elemtemp.horaini; //el inicio estaba bien antes*/
                lista->video[i].horaterm=elemtemp.horaini+elem->duracion;
                lista->video[lista->ultimo]=elemtemp;
                lista->video[lista->ultimo].horaini=elem->horaini;
                lista->video[lista->ultimo].horaterm=elem->horaini+elemtemp.duracion;

                mail(&lista->video[lista->ultimo]);

                lista->ultimo=(int)((lista->ultimo+1)%max);
                return(lista->video[i].horaini);


            }
            i--;
            if(i==(-1))
                i=max;
        }/*todavia falta revisar el primero*/


        } /*pregunta por el primero*/
        if( (lista->video[i].horamax>=(elem->horaini+lista->video[i].duracion))&&\
            (elem->duracion<=lista->video[i].duracion)&&(actual<lista->video[i].horaini))   {
                /*si el video puesto al final alcanza y el espacio es el suficiente para el*/
            /*nuevo, entonces swap*/

                elemtemp=lista->video[i];    /*guardamos el original*/
                lista->video[i]=*elem;
                lista->video[i].horaini=elemtemp.horaini; //el inicio estaba bien antes*/
                lista->video[i].horaterm=lista->video[i].horaini+elem->duracion;
                lista->video[lista->ultimo]=elemtemp;
                lista->video[lista->ultimo].horaini=elem->horaini;
                lista->video[lista->ultimo].horaterm=elem->horaini+elemtemp.duracion;

                mail(&lista->video[lista->ultimo]);

                lista->ultimo=(int)((lista->ultimo+1)%max);
                return(lista->video[i].horaini);
        }
        return (-1);//si no encuentra donde poner
}

int VerVideo(struct ListaVideo *lista) {
    struct tm *tmp;
    char buf[32];
    int i=lista->primero;
    time_t actual;

    if(i==lista->ultimo)    {
        printf("\nNo hay videos programados\n\n\n");
        return(0);
    }


	actual=time(NULL);
	while(lista->video[i].horaterm<actual)
		lista->primero=(int)((lista->primero+1)%max);

	if(lista->video[i].horaini<actual)	{ //video debe ser transmitido
		printf("\n N             Nombre      minutos al aire\n\n");
		printf("%2d %30s ",lista->video[i].num_vid, lista->video[i].nombre);
		actual-=lista->video[i].horaini;
		actual=(int)(actual/60);
		printf("%d\n",actual);
		i++;
	}
		
	printf(" N             Nombre              fecha y hora al aire\n");
    while(i!=((lista->ultimo)%max)) {

        printf("%2d %30s ",lista->video[i].num_vid, lista->video[i].nombre);
        tmp=localtime(&lista->video[i].horaini);
        strftime(buf,sizeof(buf),"%d/%m/%Y %H:%M a ",tmp);
        printf("%s",buf);
        tmp=localtime(&lista->video[i].horaterm);
        strftime(buf,sizeof(buf),"%H:%M\n",tmp);
        printf("%s",buf);
        i=(i+1)%max;
    }
}


int mail(struct ElemVideo *elem)
{
    pid_t pid;
    int pfd[2];
    int i, status,j;
    struct tm *tmp;
    char buf[32],username[60],dominio[15],mensaje[100];

    sprintf(dominio,"@elo.utfsm.cl");


    tmp=localtime(&elem->horaini);
    strftime(buf,sizeof(buf),"%d/%m/%Y a las %H:%M  ",tmp);
    sprintf(mensaje,"Su video %s ha sido programado para el dia %s",elem->nombre, buf);
  
     strcpy(username,elem->mail);

     strcat(username,dominio);

    if (pipe(pfd) < 0) {
        perror("pipe");
        exit(1);
    }

    /*
     * Create a child process.
     */
    if ((pid = fork()) < 0) {
        perror("fork");
        exit(1);
    }

    /*
     * The child process executes "mail".
     */
    if (pid == 0) {
        /*
         * Attach standard input to the pipe.
         */
        dup2(pfd[0], 0);
        close(pfd[1]);

        execl("/bin/mail", "mail",username, 0);
        perror("exec");
        _exit(127);
    }

    close(pfd[0]);

  
    write(pfd[1],mensaje ,sizeof(mensaje));
    write(pfd[1], ".\n", 5);
    write(pfd[1], ".\n", 5);

    close(pfd[1]);
    waitpid(pid, &status, 0);
}
